#include <bits/stdc++.h>
#define int long long
#define debug(fmt,...) do{fprintf(stderr,fmt,##__VA_ARGS__);fprintf(stderr,"\n");}while(0)
#define error(expr,fmt,...) do{if((expr)){debug(fmt,##__VA_ARGS__);exit(0);}}while(0)
using namespace std;

const int N = 1e5 + 5, mod = 1e9 + 7, K = 205;
int n, k;

struct edge{
    int nxt, to;
} g[N << 1];
int head[N], ec;

void add(int u, int v){
    g[++ec].nxt=head[u];
    g[ec].to=v;
    head[u]=ec;
}

struct mdint{
    int x;
    mdint(int val=0):x((val % mod + mod) % mod){}
    void adjust() {x = (x % mod + mod) % mod;}
    mdint operator+(const mdint &rhs) const {return (x+rhs.x>=mod?x+rhs.x-mod:x+rhs.x);}
    mdint operator-(const mdint &rhs) const {return (x-rhs.x<0?x-rhs.x+mod:x-rhs.x);}
    mdint operator*(const mdint &rhs) const {return (mdint)((x*rhs.x)%mod);}
    mdint operator+=(const mdint &rhs) {return *this = *this + rhs;}
    mdint operator-=(const mdint &rhs) {return *this=*this-rhs;}
    mdint operator*=(const mdint &rhs) {return *this=*this*rhs;}
    mdint operator++(){return *this=*this+1;}
    mdint operator--(){return *this=*this-1;}
    mdint operator-() const {return mdint(0)-*this;}
    bool operator>(const mdint &rhs) const {return x > rhs.x;}
    bool operator<(const mdint &rhs) const {return x < rhs.x;}
    bool operator>=(const mdint &rhs) const {return x >= rhs.x;}
    bool operator<=(const mdint &rhs) const {return x <= rhs.x;}
    bool operator==(const mdint &rhs) const {return x == rhs.x;}
    bool operator!=(const mdint &rhs) const {return x != rhs.x;}
    template<class T>
    typename enable_if<is_integral<T>::value,mdint>::type operator=(T rhs){return *this=mdint(rhs);}
    mdint operator^(int x) const {mdint res=1,a=*this;for(;x;a*=a,x>>=1) if(x&1) res*=a;return res;}
    mdint operator^(const mdint &rhs) const {return (*this) ^ rhs.x;}
    mdint inv() const {return *this^(mod-2);}
    mdint operator/(const mdint &rhs) const {return *this*rhs.inv();}
    mdint operator/=(const mdint &rhs) {return (*this)=(*this)/rhs;}
    mdint operator^=(const mdint &rhs) {return (*this)=(*this)^rhs;}
};
istream& operator>>(istream &is,mdint &x){is>>x.x;x.adjust();return is;}
ostream& operator<<(ostream &os,const mdint &x){return os<<x.x;}

mdint f[N][K], f2[K], ans[K], s[K][K];
int siz[N];

void dp(int u, int fa){
    f[u][0] = 2;siz[u] = 1;
    for(int i=head[u];i;i=g[i].nxt){
        int v = g[i].to;
        if(v == fa) continue;
        dp(v,u);
        fill(f2, f2 + k + 1, mdint(0));
        for(int a=0;a<=min(k, siz[u]);a++){
            for(int b=0;b<=min(k - a, siz[v]);b++){
                f2[a + b] += (f[v][b] * f[u][a]);
            }
        }
        for(int a=0;a<=k;a++){
            f[u][a] = f2[a];
            ans[a] -= f[v][a];
        }
        siz[u] += siz[v];
    }
    for(int a=0;a<=min(k, siz[u]);a++){
        ans[a] += f[u][a];
    }
    for(int i=min(k, siz[u]);i;i--) f[u][i] += f[u][i - 1];
    f[u][1] -= 1;
}

signed main(){
    ios::sync_with_stdio(false);
    cin.tie(0);cout.tie(0);
    cin >> n >> k;
    for(int i=1,u,v;i<n;i++){
        cin >> u >> v;
        add(u,v);add(v,u);
    }
    s[0][0] = 1;
    for(int i=1;i<=k;i++){
        for(int j=1;j<=i;j++){
            s[i][j] = s[i - 1][j - 1] + s[i - 1][j] * j;
        }
    }
    dp(1,0);
    mdint fact = 1, ret = 0;
    for(int i=0;i<=k;i++){
        ret += s[k][i] * fact * ans[i];
        fact *= (i + 1);
    }
    cout << ret;
    return 0;
}
